//
//  voroMap.h
//  voro
//
//  Created by Kristopher Krasnosky on 11/28/13.
//  Copyright (c) 2013 Kristopher Krasnosky. All rights reserved.
//

#ifndef __voro__voroMap__
#define __voro__voroMap__

#include <iostream>
#include <vector>
#include <cmath>
#include "VoronoiDiagramGenerator.h"
#include <stdio.h>

class voroMap{
public:
    struct node{
        std::vector<node *> links;
        std::vector<float> location;
        std::vector<node *> visitedBy;
        float distanceFromStart;

    };
    
    voroMap();
    void createMap(float xMin, float xMax, float yMin, float yMax, int divisions);
    node *getNode(float x,float y);
    void addLink(float x1,float y1,float x2,float y2);
    void addVoro(float *xValues, float *yValues, int count, float minSeparation);   // minSeparation is in map (real world) units
    void setStart(float x,float y);
    void setGoal(float x,float y);
    
    float magnitude(std::vector<float> vect);
    float distance(float x1,float y1, float x2,float y2);
    float distance(node *n1,node * n2);
    
    
//private:
    float mapGridScale;  // number of divisions per unit length
    float mapOrigin[2];  // in real world units i.e. meteres
    float _xMin,_xMax,_yMin,_yMax;
    float goal[2];    // the goal location
    float goalDist;
    node * goalNearestNode;
    float start[2];   // the start location
    float startDist;
    node * startNearestNode;
    
    std::vector<std::vector< node > > grid;  //
};

#endif /* defined(__voro__voroMap__) */
