//
//  voroSearch.cpp
//  voro
//
//  Created by Kristopher Krasnosky on 11/28/13.
//  Copyright (c) 2013 Kristopher Krasnosky. All rights reserved.
//

#include "voroSearch.h"
voroSearch::voroSearch(){
    lastNode=NULL;
}

bool voroSearch::itterateSearch(){
    voroMap::node * workingNode=NULL;
    workingNode=stack[stack.size()-1].node; // get the last element off the stack
    workingNode->distanceFromStart=stack[stack.size()-1].dist;
    /*
    if(workingNode->visitedBy.size()>0){
        lastNode=workingNode;
        stack.pop_back();
        return true;
    }*/
    workingNode->visitedBy.push_back(stack[stack.size()-1].cameFrom);
    lastNode=workingNode;
    stack.pop_back();  // ... and pop it off
    
    if(workingNode==map.goalNearestNode){  // we are done searching when we are at the goal node;
        return false;
    }
    
    
    long size = workingNode->links.size();
    for (long i=0; i < size ; i++) {  // go through every link that has not been visited
        //if(workingNode->links[i]->visitedBy.size()==0){
        
            insertStack(workingNode->links[i], map.distance(workingNode->links[i],workingNode)+workingNode->distanceFromStart,workingNode);
        
        //}
    }
    
    
    return true;
}

std::vector<std::vector<float> > voroSearch::search(){
    std::vector<std::vector<float> > output;
    potentialSite start {map.startNearestNode,0};  // set our start node
    stack.push_back(start);     // add it to the stack;

    
    while (itterateSearch()) {
        // do nothing;
    }
    
    output=goHome(lastNode);
    for (unsigned long i=0; i<output.size(); i++) {
        printf("{%f,%f},",output[i][0],output[i][1]);
    }
    
    return output;
}




void voroSearch::insertStack(voroMap::node *n,float dist , voroMap::node * from){
    if(n->visitedBy.size()>0){
        return;
    }
    if (stack.size()==0) {
        potentialSite ins;
        ins.node=n;
        ins.dist=dist;
        ins.cameFrom=from;
        stack.push_back(ins);
        return;
    }
    for (long i=stack.size()-1; i>=0; i--) {
        if (dist<stack[i].dist) {       // if the item is closer to start than our current node
            potentialSite ins;
            ins.node=n;
            ins.dist=dist;
            ins.cameFrom=from;
            stack.insert(stack.begin()+i+1, ins);
            return;
        }
    }
    potentialSite ins;
    ins.node=n;
    ins.dist=dist;
    ins.cameFrom=from;
    stack.insert(stack.begin(), ins);
    return;
}

std::vector<std::vector<float> > voroSearch::goHome(voroMap::node * n){
    std::vector<std::vector<float> > output;
    std::vector<float> temp(2,0);
    
    while (n!=NULL){
        output.insert(output.begin(),n->location);
        n=n->visitedBy[0];
    }
    temp[0] = map.start[0];
    temp[1] = map.start[1];
    output.insert(output.begin(),temp);
    temp[0] = map.goal[0];
    temp[1] = map.goal[1];
    output.push_back(temp);
    
    return output;
}





